client.c File Reference
Include dependency graph for client.c:

## Data Structures

struct | permission
struct | permissions_update

## Functions

SPA_EXPORT int | pw_client_register (struct pw_client *client, struct pw_client *owner, struct pw_global *parent, struct pw_properties *properties)
| Finish configuration and register a client. More...
SPA_EXPORT struct pw_core * | pw_client_get_core (struct pw_client *client)
| Get the core used to create this client. More...
SPA_EXPORT struct pw_resource * | pw_client_get_core_resource (struct pw_client *client)
| Get the client core resource. More...
SPA_EXPORT struct pw_resource * | pw_client_find_resource (struct pw_client *client, uint32_t id)
| Get a resource with the given id. More...
SPA_EXPORT struct pw_global * | pw_client_get_global (struct pw_client *client)
| Get the global associated with this client. More...
SPA_EXPORT const struct pw_properties * | pw_client_get_properties (struct pw_client *client)
| Get the client properties. More...
SPA_EXPORT void * | pw_client_get_user_data (struct pw_client *client)
| Get the client user data. More...
SPA_EXPORT void | pw_client_add_listener (struct pw_client *client, struct spa_hook *listener, const struct pw_client_events *events, void *data)
| listen to events from this client More...
SPA_EXPORT const struct pw_client_info * | pw_client_get_info (struct pw_client *client)
| Get the client information. More...
SPA_EXPORT int | pw_client_update_permissions (struct pw_client *client, const struct spa_dict *dict)
| Update the client permissions. More...
SPA_EXPORT void | pw_client_set_busy (struct pw_client *client, bool busy)
| Mark the client busy. More...

## Function Documentation

## pw_client_add_listener()

SPA_EXPORT void pw_client_add_listener | ( | struct pw_client * | client,
|  | struct spa_hook * | listener,
|  | const struct pw_client_events * | events,
|  | void * | data
| ) |  |

listen to events from this client

## pw_client_find_resource()

SPA_EXPORT struct pw_resource* pw_client_find_resource | ( | struct pw_client * | client,
|  | uint32_t | id
| ) |  |

Get a resource with the given id.

## pw_client_get_core()

SPA_EXPORT struct pw_core* pw_client_get_core | ( | struct pw_client * | client | ) |

Get the core used to create this client.

## pw_client_get_core_resource()

SPA_EXPORT struct pw_resource* pw_client_get_core_resource | ( | struct pw_client * | client | ) |

Get the client core resource.

## pw_client_get_global()

SPA_EXPORT struct pw_global* pw_client_get_global | ( | struct pw_client * | client | ) |

Get the global associated with this client.

## pw_client_get_info()

SPA_EXPORT const struct pw_client_info* pw_client_get_info | ( | struct pw_client * | client | ) |

Get the client information.

## pw_client_get_properties()

SPA_EXPORT const struct pw_properties* pw_client_get_properties | ( | struct pw_client * | client | ) |

Get the client properties.

## pw_client_get_user_data()

SPA_EXPORT void* pw_client_get_user_data | ( | struct pw_client * | client | ) |

Get the client user data.

## pw_client_register()

SPA_EXPORT int pw_client_register | ( | struct pw_client * | client,
|  | struct pw_client * | owner,
|  | struct pw_global * | parent,
|  | struct pw_properties * | properties
| ) |  |

Finish configuration and register a client.

Parameters

  client | the client to register
  owner | optional owner
  parent | the client parent
  properties | extra properties

References pw_global_add_listener(), pw_global_new(), pw_global_register(), and PW_VERSION_CLIENT.

## pw_client_set_busy()

SPA_EXPORT void pw_client_set_busy | ( | struct pw_client * | client,
|  | bool | busy
| ) |  |

Mark the client busy.

This can be used when an asynchronous operation is started and no further processing is allowed to happen for the client

## pw_client_update_permissions()

SPA_EXPORT int pw_client_update_permissions | ( | struct pw_client * | client,
|  | const struct spa_dict * | dict
| ) |  |

Update the client permissions.

References permissions_update::client, and PW_CORE_PROXY_PERMISSIONS_DEFAULT.